/* Problem URL: https://codeforces.com/contest/2132/problem/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;

        V<V<pair<int, int>>> graph(n);

        rep(i, m) {
            int a, b;
            cin >> a >> b;
            a--, b--;

            graph[a].emplace_back(b, i);
            graph[b].emplace_back(a, i);
        }

        V<V<pair<int, int>>> tree(n);

        int inf = INT32_MAX >> 1;

        int t = 0;
        vi low(n, inf);
        vi time(n, inf);
        V<bool> vis(n);
        V<bool> bridge(m);
        vi ans(n, inf);

        function<void(int, int)> dfs = [&](int i, int p) {
            low[i] = t;
            time[i] = t;
            t++;

            vis[i] = true;

            for (auto [j, id] : graph[i]) {
                if (j == p) {
                    continue;
                }

                if (vis[j]) {
                    rmin(low[i], time[j]);
                    continue;
                }

                dfs(j, i);
                tree[i].emplace_back(j, id);
                rmin(low[i], low[j]);

                if (low[j] > time[i]) {
                    bridge[id] = true;
                }
            }
        };

        dfs(0, -1);

        vi tmp;

        function<bool(int)> search = [&](int i) {
            if (i == n - 1) {
                return true;
            }

            for (auto [j, id] : tree[i]) {
                if (search(j)) {
                    if (bridge[id]) {
                        tmp.push_back(i);
                        tmp.push_back(j);
                        rmin(ans[i], id);
                        rmin(ans[j], id);
                    }

                    return true;
                }
            }

            return false;
        };

        search(0);

        set<pair<int, int>> fds;
        repv(i, tmp) {
            fds.emplace(ans[i], i);
        }

        int q;
        cin >> q;

        if (tmp.empty()) {
            while (q--) {
                int t;
                cin >> t;
                cout << "-1 ";
            }
            cout << '\n';

            continue;
        }


        auto getans = [&]() {
            queue<int> q;
            vi level(n, inf);

            for (auto [id, i] : fds) {
                q.push(i);
                level[i] = 0;
            }

            while (!q.empty()) {
                int i = q.front();
                q.pop();

                for (auto [j, id] : graph[i]) {
                    if (level[j] > level[i] + 1) {
                        level[j] = level[i] + 1;
                        ans[j] = ans[i];
                        q.push(j);
                        continue;
                    }

                    if (level[j] == level[i] + 1) {
                        rmin(ans[j], ans[i]);
                    }
                }
            }
        };

        getans();

        while (q--) {
            int x;
            cin >> x;

            cout << ans[x - 1] + 1 << ' ';
        }
        cout << '\n';
    }
}
